package;

import event.EventManager;
import flash.Lib;
import flixel.FlxG;
import flixel.FlxGame;
import fx.FxManager;
import objects.GameObjectManager;
import objects.MapLoader;
import states.IntroState;
import states.PlayState;

/**
 * author: RottenMage
 */
class GameClass extends FlxGame
{
	inline public static var gameWidth:Float = 640;
	inline public static var gameHeight:Float = 360;
	
	public function new()
	{
		var stageWidth:Int = Lib.current.stage.stageWidth;
		var stageHeight:Int = Lib.current.stage.stageHeight;
		
		var ratioX:Float = stageWidth / gameWidth;
		var ratioY:Float = stageHeight / gameHeight;
		var ratio:Float = Math.min(ratioX, ratioY);
		
		var fps:Int = 60;
		
		KeyBinding.init();
		EventManager.init();
		MapLoader.init();
		GameObjectManager.init();
		FxManager.init();
		super(Math.ceil(stageWidth / ratio), Math.ceil(stageHeight / ratio), IntroState, ratio, fps, fps);
	}
}
