package;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.BlendMode;
import flash.display.Sprite;
import flash.display.StageAlign;
import flash.display.StageQuality;
import flash.display.StageScaleMode;
import flash.display.StageQuality;
import flash.events.Event;
import flash.events.KeyboardEvent;
import flash.events.MouseEvent;
import flash.Lib;
import flash.ui.Keyboard;
import flixel.FlxG;
import flixel.FlxGame;
import flixel.util.FlxRandom;

/**
 * @author RottenMage
 */
class Main extends Sprite 
{
	
	private static var mEnterFrameFuncs:Array < Void->Void >;
	
	// Entry point
	static public function main():Void
	{	
		mEnterFrameFuncs = new Array < Void->Void > ();
		Lib.current.addChild(new Main());
	}
	
	public static function addEnterFrameEventCallbacks(func:Void->Void):Void
	{
		mEnterFrameFuncs.push(func);
	}
	
	public function new() 
	{
		super();
		
		if (stage != null)
		{
			init();
		}
		else 
		{
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
	}
	
	private function init(?E:Event):Void 
	{
		if (hasEventListener(Event.ADDED_TO_STAGE))
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		initialize();
		var game:FlxGame = new GameClass();
		addChild(game);
		FlxG.mouse.useSystemCursor = true;
		FlxG.autoPause = false;
		stage.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
		stage.addEventListener(Event.ENTER_FRAME, onEnterFrame); //todo:: do not run on release
	}
	
	private function onEnterFrame(?E:Event):Void 
	{
		for (func in mEnterFrameFuncs)
			func();
	}
	
	private function onMouseMove(evt:MouseEvent):Void
	{
		if (Std.is(FlxG.state, FlxStateExt))
		{
			var state = cast(FlxG.state, FlxStateExt);
			state.onMouseMove(evt);
		}
	}
	
	private function initialize():Void 
	{
		Lib.current.stage.align = StageAlign.TOP_LEFT;
		Lib.current.stage.scaleMode = StageScaleMode.NO_SCALE;
		Lib.current.stage.quality = StageQuality.LOW;
	}
}
