package gui;
import flixel.util.FlxSpriteUtil;
import openfl.Assets;
import flixel.FlxG;
import flixel.FlxSprite;
import flixel.text.FlxText;
import tweenx909.TweenX;
import tweenx909.EaseX;

/**
 * ...
 * @author chinykian
 */
class GuiImgButton extends GuiElement
{
	
	private var mText:FlxText;
	private var mBorder:FlxSprite;
	private var mImage:FlxSprite;
	
	public function new()
	{
		super();
	}
	
	public override function init(params:Dynamic):Void
	{
		mBorder = new FlxSprite();
		add(mBorder);
	
		mImage = new FlxSprite();
		mImage.loadGraphic(Assets.getBitmapData(params.image));
		mBorder.makeGraphic(cast(mImage.width + 4, Int), cast(mImage.height + 4, Int), 0xffffffff);
		mBorder.offset.x = 2;
		mBorder.offset.y = 2;
		add(mImage);
		
		mText = new FlxText(0, 0, cast(mImage.width, Int));
		mText.setBorderStyle(FlxText.BORDER_SHADOW, 0x11000000);
		mText.text = params.caption;
		mText.color = 0xffffff;
		mText.scrollFactor.set(0, 0);
		mText.alignment = params.alignment;
		add(mText);
		
		mText.size = params.size;
		onPressed = params.onPressed;
		startPos = params.startPos;
		endPos = params.endPos;
		delay = params.delay;
		transitionTime = params.transitionTime;
		
		mText.setPosition(startPos.x, startPos.y + mImage.height - mText.size*1.8);
		mImage.setPosition(startPos.x, startPos.y);
		mBorder.setPosition(startPos.x, startPos.y);
		
		// hack: auto transit in!
		transitIn();
	}
	
	public override function setColor(color:Int):Void
	{
		mBorder.color = color;
	}
	
	public override function setFlicker():Void
	{
		FlxSpriteUtil.flicker(mBorder, 2);
	}
	
	public override function getWidth():Float
	{
		return mImage.width;
	}
	
	public override function isMouseOver():Bool
	{
		FlxG.mouse.getScreenPosition(FlxG.camera, mMousePos);
		var hit = mImage.overlapsPoint(mMousePos);
		return hit;
	}
	
	public override function transitIn():Void
	{
		TweenX.to(mText, { x:endPos.x, y:endPos.y + mImage.height - mText.size * 1.8 } ).delay(delay).ease(EaseX.backOut).time(transitionTime);
		TweenX.to(mImage, { x:endPos.x, y:endPos.y } ).delay(delay).ease(EaseX.backOut).time(transitionTime);
		TweenX.to(mBorder, { x:endPos.x, y:endPos.y } ).delay(delay).ease(EaseX.backOut).time(transitionTime);
	}
	
	public override function transitOut():Void
	{
		TweenX.to(mText, { x:startPos.x, y:startPos.y + mImage.height - mText.size * 1.8 } ).delay(delay).ease(EaseX.backIn).time(transitionTime);
		TweenX.to(mImage, { x:startPos.x, y:startPos.y } ).delay(delay).ease(EaseX.backIn).time(transitionTime);
		TweenX.to(mBorder, { x:startPos.x, y:startPos.y } ).delay(delay).ease(EaseX.backIn).time(transitionTime);
	}
	
}