package gui;
import flixel.FlxG;
import flixel.group.FlxGroup;
import flixel.util.FlxPoint;

/**
 * ...
 * @author chinykian
 */
class GuiOverlay extends FlxGroup
{
	
	private var mGuiElements:Array<GuiElement>;

	public function new() 
	{
		super();
		mGuiElements = new Array<GuiElement>();
	}
	
	/**
	 * 
	 * @param	params - caption:string, onPressed:void->void, startPos:flxpoint, endPos:flxpoint, delay:Float
	 */
	public function addTextButton(caption:String, onPressed:Void->Void, startPos:FlxPoint, endPos:FlxPoint, size:Float=16, alignment:String="left", delay:Float=0, transitionTime:Float = 0.5):Void
	{
		var textBtn:GuiElement = new GuiTextButton();
		textBtn.init({"caption":caption, "onPressed":onPressed, "startPos":startPos, "endPos":endPos, "delay":delay, "transitionTime":transitionTime, "size":size, "alignment":alignment});
		mGuiElements.push(textBtn);
		
		add(textBtn);
	}
	
	/**
	 * 
	 * @param	params - image:string, caption:string, onPressed:void->void, startPos:flxpoint, endPos:flxpoint, delay:Float
	 */
	public function addImageButton(image:String, caption:String, onPressed:Void->Void, startPos:FlxPoint, endPos:FlxPoint, size:Float=16, alignment:String="left", delay:Float=0, transitionTime:Float = 0.5):Void
	{
		var textBtn:GuiElement = new GuiImgButton();
		textBtn.init({"image":image, "caption":caption, "onPressed":onPressed, "startPos":startPos, "endPos":endPos, "delay":delay, "transitionTime":transitionTime, "size":size, "alignment":alignment});
		mGuiElements.push(textBtn);
		
		add(textBtn);
	}
	
	public override function update():Void
	{
		super.update();
		for (i in 0 ... mGuiElements.length)
		{
			if (mGuiElements[i].isMouseOver() && FlxG.mouse.justPressed && mGuiElements[i].onPressed != null)
			{
				mGuiElements[i].onPressed();
				mGuiElements[i].setColor(0xffff00);
				mGuiElements[i].setFlicker();
			}
		}
	}
	
}