package gui;
import flixel.FlxG;
import flixel.text.FlxText;
import flixel.util.FlxSpriteUtil;
import utils.FlxTextExt;
import tweenx909.TweenX;
import tweenx909.EaseX;

/**
 * ...
 * @author chinykian
 */
class GuiTextButton extends GuiElement
{
	
	private var mText:FlxTextExt;
	
	public function new()
	{
		super();
	}
	
	public override function init(params:Dynamic):Void
	{
		mText = new FlxTextExt(0, 0, FlxG.width);
		add(mText);
		
		mText.setBorderStyle(FlxText.BORDER_SHADOW, 0x11000000);
		mText.text = params.caption;
		mText.color = 0xffffff;
		mText.scrollFactor.set(0, 0);
		
		mText.alignment = params.alignment;
		mText.size = params.size;
		onPressed = params.onPressed;
		startPos = params.startPos;
		endPos = params.endPos;
		delay = params.delay;
		transitionTime = params.transitionTime;
		
		mText.setPosition(startPos.x, startPos.y);
		
		// hack: auto transit in!
		transitIn();
	}
	
	public override function setColor(color:Int):Void
	{
		mText.color = color;
	}
	
	public override function setFlicker():Void
	{
		FlxSpriteUtil.flicker(mText, 2);
	}
	
	public override function isMouseOver():Bool
	{
		//FlxG.mouse.getScreenPosition(FlxG.camera, mMousePos);
		//var hit = mText.overlapsPoint(mMousePos);
		//return hit;
		
		FlxG.mouse.getScreenPosition(FlxG.camera, mMousePos);
		var textWidth:Float = mText.getTextWidth();
		var leftEdge = 0.0;
		var rightEdge = 0.0;
		if (mText.alignment == "left")
		{
			leftEdge = mText.x;
			rightEdge = mText.x + textWidth;
		}
		else if (mText.alignment == "right")
		{
			leftEdge = mText.x + mText.width - textWidth;
			rightEdge = mText.x + mText.width;
		}
		else
		{
			leftEdge = mText.x + mText.width/2 - textWidth/2;
			rightEdge = mText.x + mText.width/2 + textWidth/2;
		}
		
		return !(mMousePos.x < leftEdge || mMousePos.x > rightEdge ||
				 mMousePos.y < mText.y || mMousePos.y > mText.y+mText.size);
	}
	
	public override function transitIn():Void
	{
		TweenX.to(mText, { x:endPos.x, y:endPos.y } ).delay(delay).ease(EaseX.backOut).time(transitionTime);
	}
	
	public override function transitOut():Void
	{
		TweenX.to(mText, { x:startPos.x, y:startPos.y } ).delay(delay).ease(EaseX.backIn).time(transitionTime);
	}
	
}