package hud;
import flixel.FlxG;
import flixel.group.FlxGroup;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import states.PlayState;
import tweenx909.TweenX;

/**
 * ...
 * @author chinykian
 */
class GameOverText extends FlxGroup
{
	public var mText:Array<FlxText>;
	private var mTweenVals = {
		alpha1:0.0,
		alpha2:0.0,
		alpha3:0.0
	}
	
	private var mRestartButton:FlxButton;

	public function new()
	{
		super();
		
		mText = new Array<FlxText>();
		mText.push(new FlxText(0, 100, FlxG.width, "THE HOSPITAL IS NO LONGER SAFE TO WORK IN.", 16));
		mText.push(new FlxText(0, 135, FlxG.width, ".", 16));
		if (Math.random() < 0.5)
			mText.push(new FlxText(0, 200, FlxG.width, "Children and the elderly are more likely to succumb to their injuries.", 8));
		else
			mText.push(new FlxText(0, 200, FlxG.width, "Remove corpses to prevent diseases from spreading.", 8));
		
		for (text in mText)
		{
			text.alpha = 0;
			text.alignment = "center";
			add(text);
		}
		
		mRestartButton = new FlxButton(0, 0, "Restart", onRestart);
		mRestartButton.y = 400;
		mRestartButton.x = FlxG.width * 0.5 - mRestartButton.width * 0.5;
		add(mRestartButton);
	}
	
	public function onRestart():Void
	{
		FlxG.switchState(new PlayState());
	}
	
	public function initEntity(_parent:FlxGroup):Void
	{
		_parent.add(this);
	}
	
	public function start(deathCount:Int):Void
	{
		mText[1].text = "You let " + deathCount + " people die.";
		TweenX.to(mTweenVals, { alpha1:1 }, 0.5, null, 1);
		TweenX.to(mTweenVals, { alpha2:1 }, 1.5, null, 2);
		TweenX.to(mTweenVals, { alpha3:1 }, 1.5, null, 3);
		TweenX.to(mRestartButton, { y:270 }, 0.5, null, 5);
	}
	
	public override function update():Void
	{
		super.update();
		mText[0].alpha = mTweenVals.alpha1;
		mText[1].alpha = mTweenVals.alpha2;
		mText[2].alpha = mTweenVals.alpha3;
	}
	
}