package hud;
import flixel.FlxG;
import flixel.group.FlxGroup;
import flixel.text.FlxText;
import flixel.util.FlxColor;
import flixel.util.FlxColorUtil;
import flixel.util.FlxSpriteUtil;

/**
 * ...
 * @author chinykian
 */
class InfectionDisplay extends FlxGroup
{
	private var mText:FlxText;

	public function new() 
	{
		super();
		mText = new FlxText(15, FlxG.height - 30, 200, "Infection Level: 0%", 16);
		add(mText);
		
		mText.visible = false;
	}
	
	public function initEntity(_parent:FlxGroup):Void
	{
		_parent.add(this);
	}
	
	public function startBlinking():Void
	{
		FlxSpriteUtil.flicker(mText, 0, 0.25);
	}
	
	public function stopBlinking():Void
	{
		FlxSpriteUtil.stopFlickering(mText);
	}
	
	public function setPercentage(val:Float):Void
	{
		var pretext = "Infection Level: ";
		var percentage:Int = 0;
		percentage = cast(val * 100, Int);
		
		mText.text = pretext + percentage + "%";
		mText.color = FlxColorUtil.interpolateColor(0xdaa100, 0xfe1212, 100, percentage, 255);
		
		if (percentage > 0)
			mText.visible = true;
		else
			mText.visible = false;
	}
	
}