package objects;
import event.EventManager;
import event.EventType;
import flixel.FlxG;
import flixel.group.FlxGroup;
import openfl.Assets;
import patients.Patient;

/**
 * ...
 * @author chinykian
 */
class Doctor extends GameObject
{
	private var patientRef:Patient = null;

	public function new() 
	{
		super();
		loadGraphic(Assets.getBitmapData("assets/img/characters/doctor_sprite.png"), true, false, 24, 54);
		animation.add("front", [0]);
		animation.add("back", [1]);
		
		animation.play("front");
		
		offset.x = width * 0.5;
	}
	
	override public function initEntity(_parent:FlxGroup):Void 
	{
		super.initEntity(_parent);
		x += width * 0.5;
		
		EventManager.subscribe(EventType.TURN_PASSED, onTurnPassed);
	}
	
	private function onTurnPassed(evt:Int, params:Dynamic):Void
	{
		var halfHeight:Float = FlxG.height * 0.5;
		var patient:Patient = params.patient;
		if (patientRef == patient)
			return;
		patientRef = patient;
		// is top
		if (patient.y < halfHeight)
		{
			spawn(patient.x + patient.width*0.5, patient.y + 40);
		}
		else
		{
			spawn(patient.x + patient.width*0.5, patient.y - 50);
		}
	}
	
	public function spawn(posX:Float, posY:Float):Void
	{
		setPosition(posX, posY);
		alpha = 0;
	}
	
	public override function update():Void
	{
		alpha += FlxG.elapsed * 10;
		alpha = Math.min(1, alpha);
		super.update();
	}
	
}