package objects;
import flixel.FlxSprite;
import flixel.util.FlxPoint;

/**
 * ...
 * @author chinykian
 */
class Fly extends FlxSprite
{
	
	private var oscillatorX:FloatOscillator;
	private var oscillatorY:FloatOscillator;
	
	private var initialPos:FlxPoint;

	public function new() 
	{
		super();
		
		makeGraphic(2, 2, 0xff000000);
		
		oscillatorX = new FloatOscillator();
		oscillatorY = new FloatOscillator();
		initialPos = new FlxPoint();
	}
	
	public function start(_x:Float, _y:Float):Void
	{
		var ampX:Float = 15 + Math.random() * 15;
		var ampY:Float = 15 + Math.random() * 15;
		ampX *= Math.random() < 0.5 ? -1 : 1;
		ampY *= Math.random() < 0.5 ? -1 : 1;
		
		oscillatorX.start( ampX, 4 + Math.random() * 4);
		oscillatorY.start( ampY, 4 + Math.random() * 4);
		
		initialPos = new FlxPoint(_x, _y);
	}
	
	public override function update():Void
	{
		oscillatorX.update();
		oscillatorY.update();
		
		setPosition(initialPos.x + oscillatorX.value, initialPos.y + oscillatorY.value);
		
		super.update();
	}
	
}