package objects;
import event.EventManager;
import event.EventType;
import flixel.FlxSprite;
import flixel.group.FlxGroup;
import openfl.Assets;

/**
 * ...
 * @author chinykian
 */
class RealClock extends GameObject
{
	//members
	private var mMinuteSprite:FlxSprite;
	private var mHourSprite:FlxSprite;
	
	public function new() 
	{
		super();
		loadGraphic(Assets.getBitmapData("assets/img/clock/clock_base.png"), true, false, 34, 34);
		mMinuteSprite = new FlxSprite();
		mMinuteSprite.loadGraphic(Assets.getBitmapData("assets/img/clock/min_hand.png"), true, false, 34, 34);
		mMinuteSprite.animation.add("time", [0, 1, 2, 3, 4, 5]);
		mHourSprite = new FlxSprite();
		mHourSprite.loadGraphic(Assets.getBitmapData("assets/img/clock/hour_hand.png"), true, false, 34, 34);
		mHourSprite.animation.add("time", [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]);
		mHourSprite.animation.add("00", [0]);
		
		mMinuteSprite.animation.play("time");
		mMinuteSprite.animation.pause();
		mHourSprite.animation.play("time");
		mHourSprite.animation.pause();
	}
	
	public override function initEntity(_parent:FlxGroup):Void
	{
		super.initEntity(_parent);
		mMinuteSprite.setPosition(x, y);
		addSubSprite(mMinuteSprite);
		mHourSprite.setPosition(x, y);
		addSubSprite(mHourSprite);
		
		EventManager.subscribe(EventType.TURN_PASSED_OVER, onTimePassed);
	}
	
	public override function update():Void
	{
		super.update();
	}
	
	private function onTimePassed(evt:Int, params:Dynamic):Void
	{
		var currMinFrame:Int = mMinuteSprite.animation.frameIndex + 1;
		if (currMinFrame >= 6)
		{
			currMinFrame = 0;
			
			var currHourFrame:Int = mHourSprite.animation.frameIndex + 1;
			if (currHourFrame >= 12)
				currHourFrame = 0;
			mHourSprite.animation.frameIndex = currHourFrame;
		}
		mMinuteSprite.animation.frameIndex = currMinFrame;
	}
	
}