package states;

import openfl.Assets;
import flash.events.MouseEvent;
import flash.Lib;
import flixel.FlxCamera;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.group.FlxGroup;
import flixel.text.FlxText;
import flixel.util.FlxPoint;
import flixel.util.FlxSpriteUtil;
import flixel.FlxG;
import objects.*;
import gui.GuiOverlay;
import gui.GuiTextButton;

/**
* author: chinykian
*/
class CutsceneState extends FlxStateExt
{
	//members
	private var mEnableControl:Bool = false;
	private var mPaper:FlxSprite;
	var clickToContinue:FlxText;
	
	override public function create():Void
	{
		super.create();
		FlxG.camera.bgColor = 0xff111111;
		FlxG.camera.fade(0xff000000, 1.5, true, onFadeOutComplete);
		
		mPaper = new FlxSprite(0, 0, Assets.getBitmapData("assets/img/newspaper/newpapers_sprite.png"));
		mPaper.offset.x = mPaper.width * 0.5;
		mPaper.offset.y = mPaper.height;
		mPaper.setPosition(FlxG.width * 0.5, FlxG.height);
		add(mPaper);

		clickToContinue = new FlxText(0, 340, FlxG.width);
		add(clickToContinue);
		clickToContinue.size = 8;
		clickToContinue.alignment = "center";
		clickToContinue.text = "Click to continue";
		clickToContinue.alpha = 0;

		AudioMixer.enterState(this);

		FlxSpriteUtil.fadeIn(clickToContinue, 1.0);
	}
	
	private function onFadeOutComplete():Void
	{
		mEnableControl = true;
	}
	
	private function onStartGame():Void
	{
		FlxG.switchState(new PlayState());
	}
	
	override public function update():Void
	{
		if (mEnableControl && FlxG.mouse.justPressed)
		{
			mEnableControl = false;
			FlxG.camera.fade(0xff000000, 1.5, false, onStartGame);
		}
		
		super.update();
	}
	
}
