package states;

import event.EventManager;
import flash.Lib;
import flixel.FlxG;
import flixel.text.FlxText;
import tweenx909.TweenX;

class IntroState extends FlxStateExt
{
	var tweenVals = {
		alpha1: 0.0,
		alpha2: 0.0,
		alpha3: 0.0,
		alphaT: 0.0,
		alphaC: 0.0,
		alphaB: 0.0
	};
	var line1:FlxText;
	var line2:FlxText;
	var line3:FlxText;
	var title:FlxText;
	var credits:FlxText;
	var clickToContinue:FlxText;

	var mPressed:Bool = false;

	override public function create():Void
	{
		super.create();
		FlxG.camera.bgColor = 0xff000000;

		AudioMixer.enterState(this);

		line1 = new FlxText(0, 100, FlxG.width);
		add(line1);
		line1.size = 16;
		line1.alignment = "center";
		line1.text = "The city is under attack.";
		line1.alpha = 0;

		line2 = new FlxText(0, 150, FlxG.width);
		add(line2);
		line2.size = 16;
		line2.alignment = "center";
		line2.text = "Thousands are injured.";
		line2.alpha = 0;

		line3 = new FlxText(0, 200, FlxG.width);
		add(line3);
		line3.size = 16;
		line3.alignment = "center";
		line3.text = "The hospital is understaffed.";
		line3.alpha = 0;

		title = new FlxText(0, 150, FlxG.width);
		add(title);
		title.size = 32;
		title.alignment = "center";
		title.text = "T R A U M A";
		title.alpha = 0;

		credits = new FlxText(0, 220, FlxG.width);
		add(credits);
		credits.size = 8;
		credits.alignment = "center";
		credits.text = "by Rotten Mage + Praveen N";
		credits.alpha = 0;


		clickToContinue = new FlxText(0, 340, FlxG.width);
		add(clickToContinue);
		clickToContinue.size = 8;
		clickToContinue.alignment = "center";
		clickToContinue.text = "Click to continue";
		clickToContinue.alpha = 0;


		TweenX.lag([
//			TweenX.to( tweenVals, { alpha1: 1.0 } ).time( 1.0 ),
//			TweenX.to( tweenVals, { alpha2: 1.0 } ).time( 1.0 ),
//			TweenX.to( tweenVals, { alpha3: 1.0 } ).time( 1.0 ),
//			TweenX.to( tweenVals, { alpha1: 0, alpha2: 0, alpha3: 0 } ).time( 3.5 ),
//			TweenX.wait( 2 ),
			TweenX.to( tweenVals, { alphaT: 1.0 } ).time( 1.0 ),
			TweenX.to( tweenVals, { alphaC: 1.0 } ).time( 0.4 ),
			TweenX.to( tweenVals, { alphaB: 1.0 } ).time( 0.4 ),
		], 1.5);
	}

	override public function update():Void
	{
		EventManager.update();
		super.update();
		AudioMixer.update();

		line1.alpha = tweenVals.alpha1;
		line2.alpha = tweenVals.alpha2;
		line3.alpha = tweenVals.alpha3;
		title.alpha = tweenVals.alphaT;
		credits.alpha = tweenVals.alphaC;
		clickToContinue.alpha = tweenVals.alphaB;

		if (title.alpha >= 1)
		{
			if (FlxG.mouse.justPressed && !mPressed)
			{
				mPressed = true;
				FlxG.camera.fade(0, 1, false, function() {
					FlxG.switchState(new CutsceneState());
				});
			}
		}
	}
}
