package ;
import flixel.FlxG;
import flixel.util.FlxPoint;

/**
 * ...
 * @author chinykian
 */
class AnimCirclingPoint
{
	
	public var center:FlxPoint;
	public var target:Dynamic;
	public var radius:Float;
	public var speed:Float;
	
	private var mElapsed:Float;
	private var mAngle:Float; //angle in degrees
	
	/**
	 * 
	 * @param	_target object whose position to modify
	 * @param	_radius
	 */
	public function new(_target:Dynamic, _radius:Float=10) 
	{
		center  = new FlxPoint();
		target  = _target;
		radius  = _radius;
		speed   = 100;
		mElapsed = 0;
		mAngle   = 0;
	}
	
	/**
	 * update target's position based on member var center
	 */
	public function update():Void
	{
		mElapsed += FlxG.elapsed;
		mAngle += mElapsed * speed; // increment angle
		mAngle -= mAngle >= 360 ? 360 : 0;
		var toRad = Math.PI / 180.0;
		mAngle *= toRad;
		
		var newX = center.x + Math.cos(mAngle) * radius;
		var newY = center.y + Math.sin(mAngle) * radius;
		Reflect.setProperty(target, "x", newX);
		Reflect.setProperty(target, "y", newY);
	}
	
}