package ;
import flixel.util.FlxPoint;

/**
 * ...
 * @author chinykian
 */
class MathUtil
{
	
	public static function distSq(x1:Float, y1:Float, x2:Float, y2:Float):Float
	{
		var dx = x1 - x2;
		var dy = y1 - y2;
		return dx * dx + dy * dy;
	}

	public static function dist(x1:Float, y1:Float, x2:Float, y2:Float):Float
	{
		return Math.sqrt(distSq(x1, y1, x2, y2));
	}
	
	public static function rotateVector(vec:FlxPoint, angleInDeg:Float):Void
	{
		var rad = angleInDeg * (Math.PI / 180.0);
		var cosR = Math.cos(rad);
		var sinR = Math.sin(rad);
		var X = vec.x;
		var Y = vec.y;
		
		vec.x = X * cosR - Y * sinR;
		vec.y = X * sinR + Y * cosR;
	}
	
	// half-opened range
	public static function randomIntBetween(one:Int, two:Int):Int
	{
		return Math.floor(one + Math.random() * (two - one));
	}
	
}