#!/usr/bin/env python

import sys
import tmx2json
import os

if __name__ == '__main__':
    if len(sys.argv) < 2:
        sys.stderr.write('%s requires a directory argument.\n', sys.argv[0])
        sys.exit(1)

    # Get a list of all the .tmx files in the given directory and run tmx2json.py on each
    dirname = sys.argv[1]
    tmx_files = [f for f in os.listdir(dirname) if f.endswith('.tmx')]
    for tmx_file in tmx_files:
        tmx_path = dirname + '/' + tmx_file
        json_path = tmx_path[:(tmx_path.rfind('.') if '.' in tmx_path else None)] + '.json'
        if not os.path.exists(json_path) or os.path.getmtime(tmx_path) > os.path.getmtime(json_path):
            print 'Exporting ' + tmx_path
            exporter = tmx2json.Tmx2Json()
            exporter.tmx2json(tmx_path)
